#include <stdio.h>
#include <stdlib.h>
#include "comp.h"

void mergesort(int *a, int *b, int l, int r, char (*comp)(int, int))
{
	int i,j,k,m;

	if(r > l) {
		m = (r+l)/2;
		mergesort(a,b,l,m,comp);		
		mergesort(a,b,m+1,r,comp);
		for(i = m+1; i > l; i--)
			b[i-1] = a[i-1];
		for(j = m; j < r; j++)
			b[r+m-j] = a[j+1];
		for(k = l; k <= r; k++)
			a[k] = (*comp)(b[i],b[j]) ? b[i++] : b[j--];
	}
}

void ordina(int *a, int l, int r, char (*comp)(int, int))
{
	int *b = calloc(r - l + 1, sizeof(int));
	
	if(!b) {
      		fprintf(stderr,"Errore di allocazione\n");
      		exit(-1);
    	}
	mergesort(a,b,l,r,comp);
	free(b);
}

/*
char smaller(int, int);
char greater(int, int);
char coin(int,int);
*/

int main(void)
{
	int i,e,a[] = { 14, 16, 12, 11, 5, 21, 17, 14, 12 };
	static char (*choice[])(int, int) = { smaller, greater, coin };

	printf("Array da ordinare:");
	for(i = 0; i < 9; i++) printf("%d ",a[i]);
	putchar('\n');

	do {
		printf("Scegli:\n");
		printf("0: ordina in modo crescente\n");
		printf("1: ordina in modo decrescente\n");
		printf("2: rimescola casualmente\n");
		if(!(e =(scanf("%d",&i) && i >= 0 && i <= 2))) {
			printf("\nImmetti o 0 o 1 o 2.\n");
			while(getchar() != '\n');/* per svuotare l'input */
		}
	} while(!e); 

	ordina(a,0,8,choice[i]);
	for(i = 0; i < 9; i++) printf("%d ",a[i]);
	putchar('\n');
}
