#include <stdio.h>
#include "stk.h"

/* controlla che c sia una parentesi */
char parentesi(char c)
{
	return	   c == '(' || c == ')'
		|| c == '[' || c == ']'
		|| c == '{' || c == '}';	
}

/* controlla che la parentesi c chiuda la parentesi d */
char chiude(char c, char d)
{
	switch(d) {
	case '(':
		return c == ')';
	case '[':
		return c == ']';
	case '{':
		return c == '}';
	default:
		return 0;
	}	
}

int main(void)
{
	int c;
	char d;
	stack *s = createstack();

	printf("Immetti stringa:\n");
	while((c = getchar()) != EOF && c != ';') {
		if(parentesi(c)) {
			if(!empty(s)) {
				if(!chiude(c,d = pop(s))) {
					push(s,d);
					push(s,c);
				}
			} else
				push(s,c);
		}
	}
	printf("%s\n", empty(s) ? "Corretto" : "Sbagliato");
	destroystack(s);
}
